<template>
  <section :class="courseClasses">
    <section class="course-desc">
      <h2 class="text-3xl">{{ course.title }}</h2>
      <div class="text-justify leading-snug  lg:text-xl">
        {{ course.description }}
      </div>
      <div
        class="buttons w-full flex flex-col flex-no-wrap justify-center items-stretch text-center"
      >
        <a
          v-for="button in course.buttons"
          :key="button.link"
          class="bg-button hover:bg-gray-500 text-blue no-underline font-bold py-4 px-6 rounded my-2"
          :href="button.link"
        >
          {{ button.title }}
        </a>
      </div>
    </section>
    <TimeLine :events="course.events" />
  </section>
</template>

<script>
import TimeLine from "./TimeLine.vue";

export default {
  components: {
    TimeLine
  },
  props: {
    course: {
      type: Object,
      required: true,
      validator(value) {
        const keys = ["title", "description", "buttons", "events"];

        return (
          typeof value === "object" &&
          keys.reduce(
            (acc, expected) => acc && Object.keys(value).includes(expected),
            true
          )
        );
      }
    },
    order: {
      type: String,
      default: "straight",
      validator(value) {
        return value === "first" || value === "last";
      }
    }
  },
  computed: {
    courseClasses() {
      const list = ["course"];
      if (this.order === "last") list.push("course-last");

      return list;
    }
  }
};
</script>

<style lang="postcss">
.bg-button {
  background-color: var(--l-light-gray-light);
}

.course {
  @apply mx-8 p-6;
}

.course-last {
  @apply pt-10 mt-10;
  border-top: 1px solid black;
}

.course-desc > * {
  @apply my-6 text-lg;
}

.course-desc {
  @apply flex flex-col flex-no-wrap justify-start items-center;
  font-family: "Delius", cursive;
}

@screen md {
  .course {
    @apply flex flex-row flex-wrap justify-around;
  }

  .course-last {
    @apply flex-row-reverse;
  }

  .course > * {
    @apply max-w-4/10;
  }
}
</style>
